mod Ex01c logic: 'cl'

incl Mtex

incl Mauxc

loc rem 
  1. CVICENIE Z PREDMETU SPECIFIKACIA A VERIFIKACIA PROGRAMOV

loc rem 
  VASE MENO: ?
  SKUPINA: ?
  VERZIA CL: 5.81.16
  DATUM: stvrtok 26.2.2004
  ******************************************************************************
  SKUSKA (toto je len zakladny ramec, viz. tiez 1. prednaska):
   A = aspon 90 bodov
   B = aspon 80 bodov
   C = aspon 70 bodov
   D = aspon 60 bodov
   E = aspon 50 bodov
  ******************************************************************************
  2 TESTY: 60 bodov = 30+30
  FINALTERM: 40 bodov
  PREMIOVE ULOHY
  ******************************************************************************
  PMAIL: svp@nw.fmph.uniba.sk
         SUBJECT: prihlasenie sa do skupiny [2i1,2i2,2i3,2i4]
  PREDNASKA: Jan Komara
  CVICENIA: Jan Komara, Jozef Nagy
  WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/svp

rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane explicitnym 
  definiciam, primitivnej rekurzii a rekurzii s mierou. Zadanie sa sklada z 
  tychto suborov: 
  \items 
   \item \para Subor \it  mtex.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuju definicie a vlastnosti 
         pomocnych funkcii a predikatov. 
   \item \para Subor(y) \it  ex01*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

fun/0 Foo 'Tex_f0_foo'
  Foo = 0

pred/0 Poo 'Tex_p0_poo'
  Poo <-> \f

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Numeric Programs.  \end 

rem 
  \para \bf  Section. Course of Values Recursion.  \end 

rem 
  \para \bf  Course of values recursive definitions.  \end 

rem 
  \para \bf  Justification of complete induction.  \end Reduce complete 
  induction to mathematical induction. 
  \para \it  Hint.  \end Look into the section 7.3 of the text [1] - see pg. 
  187. 

theory Complete_induction_by_mathematical_induction

pred A 'Tex_p1_phi_subst'

axiom Progressivity
  \a x(\a y(y < x -> A(y)) -> A(x))

thm Conclusion
  A(x)

end theory Complete_induction_by_mathematical_induction

rem 
  \para \bf  [CL] Complete induction.  \end Syntax: 
  \items 
   \item \para The command \it  indm  \end \ft x \end invokes complete induction 
         on \ft x \end with the induction formula 
         \ft Tex2_bappl1(Tex0_phi,x) \end, where 
         \ft Tex2_bappl1(Tex0_phi,x) \end is the current goal possibly with 
         additional free variables as parameters. 
   \item \para The command \it  indm  \end \ft x \end \it  ;  \end 
         \ft Tex1_hat(y) \end invokes complete induction on \ft x \end with the 
         induction formula 
         \ft Tex2_forall(Tex1_hat(y),Tex3_bappl2(Tex0_phi,x,Tex1_hat(y))) \end, 
         where \ft Tex3_bappl2(Tex0_phi,x,Tex1_hat(y)) \end is the current goal 
         possibly with additional free variables as parameters. 
  \end

rem 
  \para \bf  Integer division.  \end 

fun/2 Div 'Tex_f2_pa_div'
  Div(x,y) = 0 <- y > 0 & x < y
  Div(x,y) = Div(x-y,y)+1 <- y > 0 & x >= y

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_div
    y > 0 -> \e r(x = Div(x,y)*y+r & r < y)
  \end

thm Spec_div
  y > 0 -> \e r(x = Div(x,y)*y+r & r < y)

rem 
  \para \bf  Greatest common divisor.  \end 

fun/2 Gcd1 'Tex_f2_pa_gcd'
  Gcd1(x,0) = x
  Gcd1(x,y) = Gcd1(y,x mod y) <- y != 0

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_gcd_divides1
    x > 0 \/ y > 0 -> Divides(Gcd1(x,y),x) & Divides(Gcd1(x,y),y)
  \end
  \eq Spec_gcd_greatest1
    (x > 0 \/ y > 0) & Divides(z,x) & Divides(z,y) -> z <= Gcd1(x,y)
  \end
  \para \it  Hint.  \end See the theorems \ft Remainder_mod \end and 
  \ft Divides_mod \end in the module \ft Maux \end. 

thm Spec_gcd_divides1
  x > 0 \/ y > 0 -> Divides(Gcd1(x,y),x) & Divides(Gcd1(x,y),y)

thm Spec_gcd_greatest1
  (x > 0 \/ y > 0) & Divides(z,x) & Divides(z,y) -> z <= Gcd1(x,y)

rem 
  \para \bf  Course of values recursive definitions with measure.  \end 

rem 
  \para \bf  Justification of induction with measure.  \end Reduce induction 
  with measure to mathematical induction. 
  \para \it  Remark.  \end Show this for the special case in the following 
  theory. 
  \para \it  Hint.  \end Look into the section 8.4 of the text [1] - see pg. 
  243. 

theory Induction_with_measure_by_mathematical_induction

fun M1 'Tex_f1_mu_subst'

pred A 'Tex_p1_phi_subst'

axiom Progressivity
  \a x(\a y(M1(y) < M1(x) -> A(y)) -> A(x))

thm Conclusion
  A(x)

end theory Induction_with_measure_by_mathematical_induction

rem 
  \para \bf  [CL] Induction with measure.  \end Syntax: 
  \items 
   \item \para The command \it  indm  \end \ft Tex_f1_mu_subst Tex1_hat(x) \end 
         invokes induction on \ft Tex1_hat(x) \end with the measure term 
         \ft Tex_f1_mu_subst Tex1_hat(x) \end and with the induction formula 
         \ft Tex2_bappl1(Tex0_phi,Tex1_hat(x)) \end, where 
         \ft Tex2_bappl1(Tex0_phi,Tex1_hat(x)) \end is the current goal possibly 
         with additional free variables as parameters. 
   \item \para The command \it  indm  \end \ft Tex_f1_mu_subst Tex1_hat(x) \end 
         \it  ;  \end \ft Tex1_hat(y) \end invokes induction on 
         \ft Tex1_hat(x) \end with the measure term 
         \ft Tex_f1_mu_subst Tex1_hat(x) \end and with the induction formula 
         \ft Tex2_forall(Tex1_hat(y),Tex3_bappl2(Tex0_phi,Tex1_hat(x),Tex1_hat(y))) \end, 
         where \ft Tex3_bappl2(Tex0_phi,Tex1_hat(x),Tex1_hat(y)) \end is the 
         current goal possibly with additional free variables as parameters. 
  \end

rem 
  \para \bf  Greatest common divisor.  \end 

fun/2 Gcd2 'Tex_f2_pa_gcd'
  Gcd2(x,y) = Gcd2(x,y-x) <- x > 0 & y > 0 & x < y
  Gcd2(x,y) = x <- x > 0 & y > 0 & x = y
  Gcd2(x,y) = Gcd2(x-y,y) <- x > 0 & y > 0 & x > y

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_gcd_divides2
    x > 0 & y > 0 -> Divides(Gcd2(x,y),x) & Divides(Gcd2(x,y),y)
  \end
  \eq Spec_gcd_greatest2
    x > 0 & y > 0 & Divides(z,x) & Divides(z,y) -> z <= Gcd2(x,y)
  \end

thm Spec_gcd_divides2
  x > 0 & y > 0 -> Divides(Gcd2(x,y),x) & Divides(Gcd2(x,y),y)

thm Spec_gcd_greatest2
  x > 0 & y > 0 & Divides(z,x) & Divides(z,y) -> z <= Gcd2(x,y)

